// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.conversion;

import fr.ifremer.adagio.core.dao.referential.Status;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.Parameter;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.adagio.core.dao.referential.pmfm.Unit;
import fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * <b>Relation Taille poids</b> :<br><br>
 * </p>
 * <p>
 * Le calcul se fait par multiplication de la taille d&#8217;un poisson par un
 * coefficient multiplicateur (convCoeff). Ce coefficient est obtenu &#224;
 * partir des caract&#233;ristiques suivantes<br>- Taxon mesur&#233; (=esp&#232;ces
 * scientifiques) : ReferenceTaxon<br>- P&#233;riode (ex : du mois de &quot;d&#233;cembre&quot;
 * au mois de &quot;juillet&quot;, ind&#233;pendant de l'ann&#233;e): startMonth, endMonth<br>-
 * Lieu ( Lieu p&#232;re si inexistant).<br>- Sexe. Cette caract&#233;ristique
 * n&#8217;&#233;tant pas renseign&#233;e syst&#233;matiquement dans la table de correspondance,
 * la recherche du coefficient doit d&#8217;abord s&#8217;effectuer sur les
 * coefficients ind&#233;pendant du sexe (Sex=null ). Si cette recherche est
 * infructueuse, et si le sexe du lot est connu (crit&#232;re de classement
 * &#8216;sexe&#8217; renseign&#233;) une nouvelle recherche doit &#234;tre lanc&#233;e sur les
 * coefficients ayant le sexe du lot consid&#233;r&#233;
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class WeightLengthConversion
    implements Serializable, Comparable<WeightLengthConversion>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 7574566403831648005L;

    // Generate 9 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Double conversionCoefficientA;

    /**
     * Coefficient de conversion taille/poids.
     * @return this.conversionCoefficientA Double
     */
    public Double getConversionCoefficientA()
    {
        return this.conversionCoefficientA;
    }

    /**
     * Coefficient de conversion taille/poids.
     * @param conversionCoefficientAIn Double
     */
    public void setConversionCoefficientA(Double conversionCoefficientAIn)
    {
        this.conversionCoefficientA = conversionCoefficientAIn;
    }

    private Double conversionCoefficientB;

    /**
     * 
     * @return this.conversionCoefficientB Double
     */
    public Double getConversionCoefficientB()
    {
        return this.conversionCoefficientB;
    }

    /**
     * 
     * @param conversionCoefficientBIn Double
     */
    public void setConversionCoefficientB(Double conversionCoefficientBIn)
    {
        this.conversionCoefficientB = conversionCoefficientBIn;
    }

    private Integer startMonth;

    /**
     * Premier mois de l'année (inclu) à partir duquel la conversion s'applique.
     * @return this.startMonth Integer
     */
    public Integer getStartMonth()
    {
        return this.startMonth;
    }

    /**
     * Premier mois de l'année (inclu) à partir duquel la conversion s'applique.
     * @param startMonthIn Integer
     */
    public void setStartMonth(Integer startMonthIn)
    {
        this.startMonth = startMonthIn;
    }

    private Integer endMonth;

    /**
     * Dernier mois de l'année (inclu) à partir duquel la conversion ne s'applique plus.
     * @return this.endMonth Integer
     */
    public Integer getEndMonth()
    {
        return this.endMonth;
    }

    /**
     * Dernier mois de l'année (inclu) à partir duquel la conversion ne s'applique plus.
     * @param endMonthIn Integer
     */
    public void setEndMonth(Integer endMonthIn)
    {
        this.endMonth = endMonthIn;
    }

    private Integer year;

    /**
     * Année sur laquelle a été établie la relation taille-poids  (Optionnel). Si non renseigné,
     * alors la relation est toujours valable ou bien  l'année est inconnue.
     * @return this.year Integer
     */
    public Integer getYear()
    {
        return this.year;
    }

    /**
     * Année sur laquelle a été établie la relation taille-poids  (Optionnel). Si non renseigné,
     * alors la relation est toujours valable ou bien  l'année est inconnue.
     * @param yearIn Integer
     */
    public void setYear(Integer yearIn)
    {
        this.year = yearIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private String comments;

    /**
     * 
     * @return this.comments String
     */
    public String getComments()
    {
        return this.comments;
    }

    /**
     * 
     * @param commentsIn String
     */
    public void setComments(String commentsIn)
    {
        this.comments = commentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 6 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private QualitativeValue sex;

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @return this.sex QualitativeValue
     */
    public QualitativeValue getSex()
    {
        return this.sex;
    }

    /**
     * Liste des valeurs qualitatives que peut prendre un paramètre.
     * Par exemple :
     * - pour le paramètre Sexe : "Mâle" et "Femelle"
     * - pour le paramètre Présentation : "Vidé", "Entier", ...
     * - pour le paramètre Catégorie : "Gros", "Moyen", ...
     * @param sexIn QualitativeValue
     */
    public void setSex(QualitativeValue sexIn)
    {
        this.sex = sexIn;
    }

    private Parameter lengthParameter;

    /**
     * Un paramètre est une propriété du milieu ou d'un élément du milieu qui contribue à en
     * apprécier les
     * caractéristiques et/ou la qualité et/ou l'aptitude à des usages.
     * Le paramètre se décline en trois types : quantitatif, qualitatif ou libre.
     * Le type quantitatif se rapporte aux paramètres qui ont une infinité de résultats numériques.
     * Le type qualitatif se rapporte aux paramètres qui ne prennent qu'un nombre limité de valeurs
     * prédéfinies pour chacun d'eux.
     * Le type libre, ou alphanumérique, correspond aux paramètres de valeurs alphanumériques, sans
     * limite
     * de valeurs possibles (hormis la longueur de la chaine : 40 max).
     * Ces trois types sont mutuellement exclusifs.
     * Exemple de paramètre :
     * • Taille (numérique)
     * • Age (numérique)
     * • Sexe (qualitatif)
     * • Catégorie commerciale (qualitatif)
     * • Présentation commerciale (qualitatif)
     * • Vrac / Hors Vrac (qualitatif)
     * • Rejet / Débarquement (qualitatif) (Discard/Landing)
     * • Stade de maturité (qualitatif) (Maturity stage)
     * • Numéro de contrat (libre - alphanumérique)
     * Cette liste n’est pas exhaustive.
     * Nombre de lignes : 130
     * @return this.lengthParameter Parameter
     */
    public Parameter getLengthParameter()
    {
        return this.lengthParameter;
    }

    /**
     * Un paramètre est une propriété du milieu ou d'un élément du milieu qui contribue à en
     * apprécier les
     * caractéristiques et/ou la qualité et/ou l'aptitude à des usages.
     * Le paramètre se décline en trois types : quantitatif, qualitatif ou libre.
     * Le type quantitatif se rapporte aux paramètres qui ont une infinité de résultats numériques.
     * Le type qualitatif se rapporte aux paramètres qui ne prennent qu'un nombre limité de valeurs
     * prédéfinies pour chacun d'eux.
     * Le type libre, ou alphanumérique, correspond aux paramètres de valeurs alphanumériques, sans
     * limite
     * de valeurs possibles (hormis la longueur de la chaine : 40 max).
     * Ces trois types sont mutuellement exclusifs.
     * Exemple de paramètre :
     * • Taille (numérique)
     * • Age (numérique)
     * • Sexe (qualitatif)
     * • Catégorie commerciale (qualitatif)
     * • Présentation commerciale (qualitatif)
     * • Vrac / Hors Vrac (qualitatif)
     * • Rejet / Débarquement (qualitatif) (Discard/Landing)
     * • Stade de maturité (qualitatif) (Maturity stage)
     * • Numéro de contrat (libre - alphanumérique)
     * Cette liste n’est pas exhaustive.
     * Nombre de lignes : 130
     * @param lengthParameterIn Parameter
     */
    public void setLengthParameter(Parameter lengthParameterIn)
    {
        this.lengthParameter = lengthParameterIn;
    }

    private Unit lengthUnit;

    /**
     * Unité d'une mesure.
     * Nombre de lignes : 30
     * @return this.lengthUnit Unit
     */
    public Unit getLengthUnit()
    {
        return this.lengthUnit;
    }

    /**
     * Unité d'une mesure.
     * Nombre de lignes : 30
     * @param lengthUnitIn Unit
     */
    public void setLengthUnit(Unit lengthUnitIn)
    {
        this.lengthUnit = lengthUnitIn;
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * 
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * 
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private Location location;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    /**
     * Returns <code>true</code> if the argument is an WeightLengthConversion instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof WeightLengthConversion))
        {
            return false;
        }
        final WeightLengthConversion that = (WeightLengthConversion)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link WeightLengthConversion}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link WeightLengthConversion}.
         * @return new WeightLengthConversionImpl()
         */
        public static WeightLengthConversion newInstance()
        {
            return new WeightLengthConversionImpl();
        }

        /**
         * Constructs a new instance of {@link WeightLengthConversion}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param conversionCoefficientA Double
         * @param conversionCoefficientB Double
         * @param startMonth Integer
         * @param endMonth Integer
         * @param status Status
         * @param lengthParameter Parameter
         * @param lengthUnit Unit
         * @param referenceTaxon ReferenceTaxon
         * @param location Location
         * @return newInstance
         */
        public static WeightLengthConversion newInstance(Double conversionCoefficientA, Double conversionCoefficientB, Integer startMonth, Integer endMonth, Status status, Parameter lengthParameter, Unit lengthUnit, ReferenceTaxon referenceTaxon, Location location)
        {
            final WeightLengthConversion entity = new WeightLengthConversionImpl();
            entity.setConversionCoefficientA(conversionCoefficientA);
            entity.setConversionCoefficientB(conversionCoefficientB);
            entity.setStartMonth(startMonth);
            entity.setEndMonth(endMonth);
            entity.setStatus(status);
            entity.setLengthParameter(lengthParameter);
            entity.setLengthUnit(lengthUnit);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setLocation(location);
            return entity;
        }

        /**
         * Constructs a new instance of {@link WeightLengthConversion}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param conversionCoefficientA Double
         * @param conversionCoefficientB Double
         * @param startMonth Integer
         * @param endMonth Integer
         * @param year Integer
         * @param description String
         * @param comments String
         * @param updateDate Timestamp
         * @param status Status
         * @param sex QualitativeValue
         * @param lengthParameter Parameter
         * @param lengthUnit Unit
         * @param referenceTaxon ReferenceTaxon
         * @param location Location
         * @return newInstance WeightLengthConversion
         */
        public static WeightLengthConversion newInstance(Double conversionCoefficientA, Double conversionCoefficientB, Integer startMonth, Integer endMonth, Integer year, String description, String comments, Timestamp updateDate, Status status, QualitativeValue sex, Parameter lengthParameter, Unit lengthUnit, ReferenceTaxon referenceTaxon, Location location)
        {
            final WeightLengthConversion entity = new WeightLengthConversionImpl();
            entity.setConversionCoefficientA(conversionCoefficientA);
            entity.setConversionCoefficientB(conversionCoefficientB);
            entity.setStartMonth(startMonth);
            entity.setEndMonth(endMonth);
            entity.setYear(year);
            entity.setDescription(description);
            entity.setComments(comments);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setSex(sex);
            entity.setLengthParameter(lengthParameter);
            entity.setLengthUnit(lengthUnit);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setLocation(location);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(WeightLengthConversion o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getConversionCoefficientA() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getConversionCoefficientA().compareTo(o.getConversionCoefficientA()));
            }
            if (this.getConversionCoefficientB() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getConversionCoefficientB().compareTo(o.getConversionCoefficientB()));
            }
            if (this.getStartMonth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartMonth().compareTo(o.getStartMonth()));
            }
            if (this.getEndMonth() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndMonth().compareTo(o.getEndMonth()));
            }
            if (this.getYear() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getYear().compareTo(o.getYear()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getComments().compareTo(o.getComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// WeightLengthConversion.java merge-point
}